package ru.dbotthepony.mc.otm.client.render.entity

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.client.renderer.MultiBufferSource
import net.minecraft.client.renderer.entity.EntityRenderer
import net.minecraft.client.renderer.entity.EntityRendererProvider
import net.minecraft.resources.ResourceLocation
import ru.dbotthepony.mc.otm.client.render.TextAlign
import ru.dbotthepony.mc.otm.client.render.drawAligned
import ru.dbotthepony.mc.otm.client.render.rotateAroundPoint
import ru.dbotthepony.mc.otm.client.render.translation
import ru.dbotthepony.mc.otm.core.Angle
import ru.dbotthepony.mc.otm.entity.PlasmaProjectile
import kotlin.math.PI

class PlasmaProjectileRenderer(context: EntityRendererProvider.Context) : EntityRenderer<PlasmaProjectile>(context) {
	override fun getTextureLocation(p_114482_: PlasmaProjectile): ResourceLocation {
		throw UnsupportedOperationException()
	}

	override fun render(
		entity: PlasmaProjectile,
		p_114486_: Float,
		p_114487_: Float,
		pose: PoseStack,
		buffer: MultiBufferSource,
		p_114490_: Int
	) {
		super.render(entity, p_114486_, p_114487_, pose, buffer, p_114490_)

		pose.pushPose()
		pose.scale(0.03f, 0.03f, 0.03f)
		pose.rotateAroundPoint(pose.translation(), Angle.deg(roll = entity.xRot.toDouble(), yaw = entity.yRot.toDouble(), pitch = 180.0))
		font.drawAligned(pose, "PLASMA", TextAlign.CENTER_CENTER, 0f, 0f, 0xFFFFFF)
		pose.popPose()
	}
}
