package ru.dbotthepony.mc.otm.client.screen.panels

import net.minecraft.resources.ResourceLocation
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.client.render.AbstractSkinElement
import ru.dbotthepony.mc.otm.client.render.AtlasSkinElement
import ru.dbotthepony.mc.otm.client.render.WidgetLocation
import ru.dbotthepony.mc.otm.client.render.element
import ru.dbotthepony.mc.otm.client.render.subElement

object ScrollBarConstants {
	const val WIDTH = 14f
	const val SLIM_WIDTH = 8f

	val BACKGROUND = AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar/background"), 14f, 8f)
	val BACKGROUND_SLIM = AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar_slim/background"), 8f, 8f)

	val TOP = 					BACKGROUND.subElement(height = 2f)
	val BODY = 					BACKGROUND.subElement(y = 2f, height = 5f)
	val BOTTOM = 				BACKGROUND.subElement(y = 6f, height = 2f)

	val BUTTON = 				AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar/idle"), 12f, 15f)
	val BUTTON_HOVER = 			AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar/hovered"), 12f, 15f)
	val BUTTON_PRESS = 			AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar/pressed"), 12f, 15f)
	val BUTTON_DISABLED = 		AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar/disabled"), 12f, 15f)

	val SLIM_TOP = 				BACKGROUND_SLIM.subElement(height = 2f)
	val SLIM_BODY = 			BACKGROUND_SLIM.subElement(y = 2f, height = 5f)
	val SLIM_BOTTOM = 			BACKGROUND_SLIM.subElement(y = 6f, height = 2f)

	val SLIM_BUTTON = 			AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar_slim/idle"), 6f, 15f)
	val SLIM_BUTTON_HOVER = 	AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar_slim/hovered"), 6f, 15f)
	val SLIM_BUTTON_PRESS = 	AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar_slim/pressed"), 6f, 15f)
	val SLIM_BUTTON_DISABLED = 	AtlasSkinElement(ResourceLocation(OverdriveThatMatters.MOD_ID, "widgets/scrollbar_slim/disabled"), 6f, 15f)
}
