package ru.dbotthepony.mc.otm.graph.matter

import ru.dbotthepony.mc.otm.capability.matter.*
import ru.dbotthepony.mc.otm.graph.Graph6Node

interface IMatterGraphListener {
	fun onPatternAdded(state: IPatternState) {}
	fun onPatternRemoved(state: IPatternState) {}
	fun onPatternUpdated(newState: IPatternState, oldState: IPatternState) {}

	fun onMatterTaskCreated(task: IReplicationTask<*>) {}
	fun <T : IReplicationTask<*>> onMatterTaskUpdated(newState: T, oldState: T) {}
	fun onMatterTaskFinished(state: IReplicationTask<*>) {}
	fun onMatterTaskRemoved(state: IReplicationTask<*>) {}
}

interface IMatterGraphNode : IMatterGraphListener {
	fun getMatterHandler(): IMatterHandler? = null
	fun getPatternHandler(): IPatternStorage? = null
	fun getTaskHandler(): IReplicationTaskProvider? = null

	val matterNode: Graph6Node<IMatterGraphNode>
	val matterGraph: MatterNetworkGraph? get() = matterNode.graph as MatterNetworkGraph?
}
