package ru.dbotthepony.mc.otm.graph.storage

import ru.dbotthepony.mc.otm.graph.Graph6Node
import ru.dbotthepony.mc.otm.storage.IStorage

interface IStorageGraphNode {
	/**
	 * Called by storage graph on node being attached to it
	 */
	fun attachComponents(to: StorageNetworkGraph)

	/**
	 * Called by storage graph on node being detached from it
	 *
	 * This is NOT called when graph is being destroyed (e.g. even by merging
	 * with another graph).
	 */
	fun removeComponents(from: StorageNetworkGraph)

	val storageNode: Graph6Node<IStorageGraphNode>
	val storageGraph: StorageNetworkGraph? get() = storageNode.graph as StorageNetworkGraph?
}
